﻿using System.Collections.ObjectModel;
using Telerik.XamarinForms.Chart;
using Xamarin.Forms;

namespace AxisLabelFormatterExample
{
    public partial class AxisLabelFormatterExamplePage : ContentPage
    {
        public AxisLabelFormatterExamplePage()
        {
            InitializeComponent();
            this.BindingContext = new ViewModel();
            SetInheritedBindingContext(chart.VerticalAxis, chart.BindingContext);
        }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            this.Data = GetCategoricalData();
            this.ValueLabelFormatter = new ValueLabelFormatter();
        }

        public ObservableCollection<ChartData> Data { get; set; }

        public ValueLabelFormatter ValueLabelFormatter { get; set; }

        private static ObservableCollection<ChartData> GetCategoricalData()
        {
            var data = new ObservableCollection<ChartData>();
            for (int i = 0; i < 5; i++)
            {
                data.Add(new ChartData
                {
                    Category = ((char)('A' + i)).ToString(),
                    Value = i
                });
            }

            return data;
        }
    }

    public class ChartData
    {
        public string Category { get; set; }

        public double Value { get; set; }
    }

    public class CategoryLabelFormatter : LabelFormatterBase<string>
    {
        public override string FormatTypedValue(string value)
        {
            return string.Format("{0} group", value);
        }
    }

    public class ValueLabelFormatter : LabelFormatterBase<double>
    {
        public override string FormatTypedValue(double value)
        {
            return value + " km";
        }
    }
}
